-- Prydaz Saves 
-- by Vildiesel EU-Well of Eternity

local tremove, format = table.remove, string.format

local addonName, addonTable = ...
local L = addonTable.L

-- v1.0.0
addonTable.version = 1000

local startTime

local svar
local cache, pool = {}, {}
local s, unit -- current section, current unit

--local console

local function getTable()
 return #pool > 0 and tremove(pool, 1) or {}
end

local function freeTable(t)
 wipe(t)
 pool[#pool + 1] = t
end

local function PrydazSaved()
 --console:AddLine("|cff00ff00"..unit.."|r> |cffffff00Prydaz Saved!")
 
 if not svar.saves[unit] then svar.saves[unit] = getTable() end
 
 local save = svar.saves[unit]
 
 save[#save + 1] = s.time
end

local function CloseSection()
 --console:AddLine("|cff00ff00"..unit.."|r> Section Closed")
 s.closed = true
end

local function Determine()
 if s.damage + s.absorbed > s.maxHP then
  s.saved = true
  s.time = date("%H:%M:%S")
  if not s.closed then
   CloseSection()
  end
 end
end

local function NewSection(spellname)
 local total = select(17, UnitBuff(unit, spellname))
 
 if not total then return end
 
 if not cache[unit] then
  cache[unit] = getTable()
 else
  Determine()
  if s.saved then
   PrydazSaved()
  end
 end

 local t = cache[unit]
 s = getTable()
 t[#t + 1] = s

 s.prydaztotal = total
 s.absorbed = 0
 s.damage = 0
 s.healing = 0
 s.time = 0
 s.saved = false
 s.time = 0
 s.maxHP = UnitHealth(unit)
 --console:AddLine("|cff00ff00"..unit.."|r> New Section: |cff00ffff"..total.."|r")
 --console:AddLine("|cff00ff00"..unit.."|r> - Start Tracking")
end

local function Damage(dam, source)
 s.damage = s.damage + dam
 --console:AddLine("|cff00ff00"..unit.."|r> damage |cffff0000"..dam)
 Determine()
end

local function Heal(heal)

 if type(heal) ~= "number" then return end

 s.healing = s.healing + heal

 if s.healing >= s.maxHP * 0.14 then
  if s.fullyabsorbed == true then
   CloseSection()
   Determine()
  end
  s.damage = 0
  s.healing = 0
  s.maxHP = UnitHealth(unit)
  if not s.closed then
   --console:AddLine("|cff00ff00"..unit.."|r> - Reset by healing")
  end
 end
 --console:AddLine("|cff00ff00"..unit.."|r> heal "..heal)
end

local function PrydazAbsorb(amount)
 
 s.absorbed = s.absorbed + amount

 --console:AddLine("|cff00ff00"..unit.."|r> absorbed |cff00ffff"..amount.."|r (|cffff0000"..s.absorbed.."|r total)")
 
 if s.absorbed == s.prydaztotal then
  s.fullyabsorbed  = true
  --console:AddLine("|cff00ff00"..unit.."|r> Closing section..")
 end
 
 Damage(0)
end


--[[
SWING_DAMAGE: amount, school, resisted, blocked, absorbed, critical, glancing, crushing
RANGE_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
SPELL_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
SPELL_PERIODIC_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
]]

-- event handler
local eventframe = CreateFrame("FRAME","PrydazSavesEventFrame")
eventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
eventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
eventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
eventframe:RegisterEvent("VARIABLES_LOADED")
function eventframe.COMBAT_LOG_EVENT_UNFILTERED(...)
 local timestamp, e = ...
 local sourceName   = select(5, ...)
 local destName     = select(9, ...)

 unit = destName
 if (e == "SPELL_AURA_REFRESH" or e == "SPELL_AURA_APPLIED") and select(12, ...) == 207472 then
  NewSection(select(13, ...))
 end
 
 if not cache[destName] then return end
 
 s = cache[destName][#cache[destName]]

 if e == "UNIT_DIED" then
  s.prydaztotal = total
  s.absorbed = 0
  s.damage = 0
  s.healing = 0
  s.time = 0
  s.saved = false
  s.time = 0
  CloseSection()
 end
 
 if s.closed then return end

 if e == "SPELL_ABSORBED" then
  if select(16, ...) == 207472 then
   PrydazAbsorb(select(19, ...))
  elseif select(19, ...) == 207472 then
   PrydazAbsorb(select(22, ...))
  else
   Heal(select(22, ...) or select (19, ...))
  end
 end
 
 if e:find("_DAMAGE") then
  local dam = select(e == "SWING_DAMAGE" and 12 or 15, ...)
  Damage(dam, sourceName)
 elseif e:find("_HEAL") then
  local heal = select(15, ...)
  Heal(heal)
 end
end

local function Reset()
 startTime = time()
 svar.saves = getTable()
end

function eventframe.PLAYER_REGEN_DISABLED()

end

function eventframe.PLAYER_REGEN_ENABLED()
 --Report()
end

function eventframe.VARIABLES_LOADED()
 if not PrydazSaves_Options then PrydazSaves_Options = {} end
 svar = PrydazSaves_Options
 
 svar.saves = getTable()

 -- version checks here
 svar.version = addonTable.version
 
 --addonTable:CreateMainframe()
 --console = PrydazSavesConsole.left_text
 
 Reset()
end

eventframe:SetScript("OnEvent", function(self, event, ...) self[event](...) end)

local function secondstotime(seconds)
 local time = ""
 local count = 0
 local tempTime
 seconds = floor(seconds)
 if seconds >= 86400 then
  count = count + 1
  tempTime = floor(seconds / 86400)
  time = format("%s days",tempTime)
  seconds = mod(seconds, 86400)
 end
 if count < 2 and seconds >= 3600 then
 	count = count + 1
 	if time ~= "" then
 	 time = time..TIME_UNIT_DELIMITER
 	end
	tempTime = floor(seconds / 3600)
 	time = time..format("%s hr", tempTime)
 	seconds = mod(seconds, 3600)
 end
 if count < 2 and seconds >= 60 then
 	count = count + 1
 	if time ~= "" then
 		time = time..TIME_UNIT_DELIMITER
 	end
    tempTime = floor(seconds / 60)
 	time = time..format("%s min", tempTime)
 	seconds = mod(seconds, 60)
 end
 if count < 2 and seconds > 0 then
 	if time ~= "" then
 	 time = time..TIME_UNIT_DELIMITER
 	end
 	seconds = format("%d", seconds)
 	time = time..format("%s sec", seconds)
 end
 return time
end

local function SlashCmd(arg)
 --PrydazSavesConsole:Show()
 
 if arg == "reset" then
  Reset()
  return
 end
 
 if arg == "check" then
  print(addonName, " - players with Prydaz:")
  for u in pairs(cache) do
   print(u)
  end
  return
 end

 local function msg(m)
  if arg == "" then
   print(m)
  elseif arg == "raid" then
   SendChatMessage(m, "RAID")
  elseif arg == "party" then
   SendChatMessage(m, "PARTY")
  elseif arg == "officer" then
   SendChatMessage(m, "OFFICER")
  else
   SendChatMessage(m, "WHISPER", nil, arg)  
  end
 end

 msg(addonName.." - players saved in the last "..secondstotime(time() - startTime))
 for u,data in pairs(svar.saves) do
  for k,v in pairs(data) do
   msg(u.." at "..v)
  end
 end
 msg(addonName.." - end.")
end

-- slash commands
SLASH_PrydazSaves1 = "/ps"
SLASH_PrydazSaves2 = "/prydazsaves"
SlashCmdList["PrydazSaves"] = SlashCmd
